| Python Script Engine 8.3 GL Studio Editor Python Script API

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Gls3DCable Class Reference
Inheritance diagram for Gls3DCable:

## Public Types
enum | ECollisionStyle { COLLISIONSTYLE_NONE = 0 , COLLISIONSTYLE_FAST = 1 }
Public Types inherited from DisplayObject
enum | MemberAccess_e { PUBLIC , PRIVATE , PROTECTED }
enum | PickableType_e { UNPICKABLE , FIRST_PICK , BEST_PICK , ALWAYS_PICK }
enum | PolygonClose_e { POLY_OPEN , POLY_CLOSED }
enum | PolygonMode_e { POLY_MODE_UNDEFINED , POLY_MODE_POINTS , POLY_MODE_OUTLINE , POLY_MODE_FILLED , POLY_MODE_FILL_AND_OUTLINE }
enum | ShadingType_e { SHADING_FLAT , SHADING_GOURAUD }
enum | TextureMap_e { TEXTURE_MAP_MODULATE , TEXTURE_MAP_DECAL , TEXTURE_MAP_BLEND , TEXTURE_MAP_REPLACE }
enum | TextureFilter_e { TEXTURE_FILTER_NEAREST , TEXTURE_FILTER_LINEAR , TEXTURE_FILTER_NEAREST_MIPMAP_NEAREST , TEXTURE_FILTER_LINEAR_MIPMAP_LINEAR , TEXTURE_FILTER_NEAREST_MIPMAP_LINEAR , TEXTURE_FILTER_LINEAR_MIPMAP_NEAREST }
enum | TessellateType_e { TESSELLATE_UNION , TESSELLATE_INTERSECT , TESSELLATE_DIFFERENCE }
enum | RotationAxis_e { X_AXIS , Y_AXIS , Z_AXIS }
enum | LineStyle_e { SOLID_LINE_STYLE , SMALL_DOTTED_LINE_STYLE , DOTTED_LINE_STYLE , DASHED_LINE_STYLE , DOT_DASHED_LINE_STYLE , SMALL_DASHED_LINE_STYLE }
enum | AlphaMode_e { ALPHA_MODE_UNDEFINED , ALPHA_MODE_OPAQUE , ALPHA_MODE_2_LEVEL , ALPHA_MODE_256_LEVEL }

## Public Member Functions
| Gls3DCable ()
| Gls3DCable (Gls3DCable &src)
| Gls3DCable (DisplayObjectArray *objs)
int | CollisionStyle ()
void | CollisionStyle (int value)
float | Flexibility ()
void | Flexibility (float value)
bool | Gravity ()
void | Gravity (bool value)
float | Length ()
void | Length (float value)
unsigned int | NumberOfSegments ()
void | NumberOfSegments (unsigned int value)
unsigned int | NumberOfSides ()
void | NumberOfSides (unsigned int value)
float | Radius ()
void | Radius (float value)
Public Member Functions inherited from Group
| Group ()
| Group (DisplayObjectArray *objs)
void | Ungroup ()
void | InsertObject (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION, bool renameName=false)
void | InsertObjectAllowDuplicateNames (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION)
void | MoveObjectToGroup (DisplayObject *obj, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION, bool renameName=false)
void | MoveObjectToGroupAllowDuplicateNames (DisplayObject *obj, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION)
void | ReorderObject (unsigned int oldIndex, unsigned int newIndex)
DisplayObjectArray * | GetObjectList ()
DisplayObject * | GetObjectByIndex (unsigned int index)
unsigned int | Count ()
void | CalculateTextureCoordinates (void)
void | SetGroupLocation (Vertex &v)
void | CalculateBoundingBox ()
unsigned int | GetCount ()
Public Member Functions inherited from DisplayObject
bool | isNULL ()
String | GetName ()
String | SetName (String name)
void | SetProtectionMode (DisplayObject::MemberAccess_e mode)
DisplayObject::MemberAccess_e | GetProtectionMode (void)
void | SetLocked (bool val)
bool | GetLocked (void)
bool | GetGenerateMemberVariable ()
void | SetGenerateMemberVariable (bool b)
bool | GetAntiAliasing ()
void | SetAntiAliasing (bool antiAliasing)
bool | GetBlinking ()
void | SetBlinking (bool blinking)
float | GetBlinkRate ()
void | SetBlinkRate (float rate)
int | GetAlphaMode ()
void | SetAlphaMode (int mode)
bool | GetCullBackFaces ()
void | SetCullBackFaces (bool cullFaces)
bool | GetZBufferTestedFlag ()
void | SetZBufferTestedFlag (bool tested)
bool | GetAffectZBufferFlag ()
void | SetAffectZBufferFlag (bool affect)
bool | GetLightingEnabledFlag ()
void | SetLightingEnabledFlag (bool enabled)
DisplayObject::PickableType_e | GetPickMode ()
void | SetPickMode (DisplayObject::PickableType_e mode)
bool | GetVisibilityFlag ()
void | SetVisibilityFlag (bool visible)
PolygonClose_e | GetClosePolygonFlag ()
void | SetClosePolygonFlag (PolygonClose_e closePolygon)
PolygonMode_e | GetPolygonMode ()
void | SetPolygonMode (PolygonMode_e polygonMode)
ShadingType_e | GetShadingMode ()
void | SetShadingMode (ShadingType_e shadingMode)
Vertex | GetLocation ()
void | SetLocation (Vertex loc)
Vertex | GetRotationPoint ()
void | SetRotationPoint (Vertex rotPoint)
GlsMatrixAffine * | GetDcsMatrix ()
void | SetDcsMatrix (GlsMatrixAffine *matrix)
int | GetMaterialIndex ()
void | SetMaterialIndex (int matIndex)
String | GetObjectClassName ()
int | GetTextureIndex ()
void | SetTextureIndex (int texIndex)
TextureMap_e | GetTextureMappingTechnique ()
void | SetTextureMappingTechnique (TextureMap_e mappingTechnique)
bool | GetTextureRepeat ()
void | SetTextureRepeat (bool repeat)
disti::GlsColor | GetBlendingColor ()
void | SetBlendingColor (GlsColor blendColor)
DisplayObject::TextureFilter_e | GetTextureMagnificationFilter ()
void | SetTextureMagnificationFilter (DisplayObject::TextureFilter_e filter)
DisplayObject::TextureFilter_e | GetTextureMinificationFilter ()
void | SetTextureMinificationFilter (DisplayObject::TextureFilter_e filter)
std::vector< Vector > | GetTextureCoordinates ()
void | SetTextureCoordinates (std::vector< Vector > &texVerts)
void | GetTextureCoordinates (VertexArray *texVerts)
void | SetTextureCoordinates (VertexArray &texVerts)
void | GetTexturePoints (VertexArray *texVerts)
void | SetTexturePoints (VertexArray &texVerts)
void | SetTexturePoints (std::vector< Vector > &texVerts)
std::vector< Vector > | GetTexturePoints ()
void | GetVertices (VertexArray *verts)
void | SetVertices (VertexArray &verts)
String | GetInitialization ()
void | SetInitialization (String initCode)
String | GetCallbackCode ()
void | SetCallbackCode (String cbCode)
DisplayObject * | DuplicateObject (Document *doc=NULL)
DisplayObject * | TessellateObject ()
DisplayObject * | ExtrudeObject (float amount)
void | RotateObject (float amount, RotationAxis_e axis)
void | TranslateObject (float x, float y, float z)
void | ScaleObject (float x, float y, float z, Vertex *anchor=NULL)
void | LineWidth (float width)
float | LineWidth ()
LineStyle_e | LineStyle ()
void | LineStyle (LineStyle_e style)
GlsColor | LineColor ()
void | LineColor (GlsColor color)
GlsColor | FillColor ()
void | FillColor (GlsColor color)
void | GetExtents (Vector &min, Vector &max)
bool | HasUserDefinedAttribute (String attribName)
std::map< String, String > | GetUserDefinedAttributes ()
UserDefinedValueAttributeList | GetAllUserDefinedAttributes ()
String | GetUserDefinedAttributeValue (String attribName)
| typemap (check) String attribName
void | SetUserDefinedAttributeValue (String attribName, String value)
DisplayObject * | GetParent ()
Document * | GetDocument ()
String | AlternateClassName ()
void | AlternateClassName (String name)
String | GetAlternateClassHeaderFile ()
void | SetAlternateClassHeaderFile (String name)
String | GetResources ()
String | GetRuntimeResources (bool recursive)
String | GetAttributeType (String attribName)
String | GetAttributeValueString (String attribName)
void | SetAttributeValueString (String attribName, String value)
unsigned int | RegisterObserver (String attribName, PyObject *pyfunc)
void | UnregisterObserver (String attribName, unsigned int id)
std::vector< Vector > | GetNormals ()
void | SetNormals (std::vector< Vector > &normals)
std::vector< CustomAttributeInfo > | GetExtraAttributes ()
DisplayObject * | CloneObject ()
void | CopyProperties (DisplayObject *sourceObj)
void | SetLocation (Vector loc)
GlsMatrixAffine | GetObjectCoordinatesTransform (DisplayObject *targetObject)
void | CalculateParentBoundingBox ()
void | SetOrigin (Vertex &vert)

## Static Public Member Functions
static Gls3DCable * | CastToGls3DCable (DisplayObject *obj)
Static Public Member Functions inherited from Group
static Group * | CastToGroup (DisplayObject *obj)

## Additional Inherited Members
Static Public Attributes inherited from Group
static int | DEFAULT_GROUP_LOCATION = -1
Static Public Attributes inherited from DisplayObject
static int | TEXTURE_INDEX_NONE = -1

## Detailed Description

Plug-in used to create 3d cables in GL Studio.

## Member Enumeration Documentation

## ◆ ECollisionStyle

enum Gls3DCable::ECollisionStyle

CollisionStyle values.

Enumerator
COLLISIONSTYLE_NONE |
COLLISIONSTYLE_FAST |

## Constructor & Destructor Documentation

## ◆ Gls3DCable() [1/3]

Gls3DCable::Gls3DCable | ( |  | ) |

default constructor

## ◆ Gls3DCable() [2/3]

Gls3DCable::Gls3DCable | ( | Gls3DCable & | src | ) |

copy constructor

## ◆ Gls3DCable() [3/3]

Gls3DCable::Gls3DCable | ( | DisplayObjectArray * | objs | ) |

Convert-to-Gls3DCable constructor.

Parameters

  objs | Array of display objects to be combined into the 3D Cable

## Member Function Documentation

## ◆ CastToGls3DCable()

static Gls3DCable * Gls3DCable::CastToGls3DCable | ( | DisplayObject * | obj | ) |
| static

Casts the Display Object as a Gls3DCable NOTE: perform an isNULL check on the returned value to ensure the cast was accomplished.

Parameters

  obj | objects to cast

Returns
  Gls3DCable the Gls3DCable

Exceptions

  CEIException |

## ◆ CollisionStyle() [1/2]

int Gls3DCable::CollisionStyle | ( |  | ) |

Gets the collision style.

Returns
  The current collision style

## ◆ CollisionStyle() [2/2]

void Gls3DCable::CollisionStyle | ( | int | value | ) |

Sets the collision style COLLISIONSTYLE_NONE will disable all collision detection and therefore any cable deformation caused thereby.

COLLISIONSTYLE_FAST will check for collisions with other objects in the scene, but will only move / orient the cable midpoint such that it appears as though the cable is laying flat on a single surface.

Parameters

  value | The collision mode for the cable.

## ◆ Flexibility() [1/2]

float Gls3DCable::Flexibility | ( |  | ) |

Gets the flexibility constant.

Returns
  How stiff the cable is.

## ◆ Flexibility() [2/2]

void Gls3DCable::Flexibility | ( | float | value | ) |

Sets the flexibility constant.

Parameters

  value | Controls how stiff the cable is. The value should be in the range of 0 to 1, inclusive. 0 is very inflexible, while 1 is very flexible.

## ◆ Gravity() [1/2]

bool Gls3DCable::Gravity | ( |  | ) |

Gets the gravity enable flag.

Returns
  Returns whether or not gravity is simulated on the cable.

## ◆ Gravity() [2/2]

void Gls3DCable::Gravity | ( | bool | value | ) |

Sets the gravity enable flag.

Parameters

  value | Whether or not to simulate gravity on the cable.

## ◆ Length() [1/2]

float Gls3DCable::Length | ( |  | ) |

Gets the length of the cable.

Returns
  The length of the cable in logical units.

## ◆ Length() [2/2]

void Gls3DCable::Length | ( | float | value | ) |

Sets the length of the cable This is the cable length when not under duress (the cable will stretch when the end-points are moved too far from each other).

Parameters

  value | The approximate length of the cable in logical units.

## ◆ NumberOfSegments() [1/2]

unsigned int Gls3DCable::NumberOfSegments | ( |  | ) |

Gets the number of segments.

Returns
  The number of segments in the cable.

## ◆ NumberOfSegments() [2/2]

void Gls3DCable::NumberOfSegments | ( | unsigned int | value | ) |

Sets the number of segments This is the number of segments in the entire length of the cable.

A cable with one section (that is, with only two control objects) would be a straight cylinder connecting two points, incapable of bending.
The higher this number, the smoother your cable will appear.

Parameters

  value | The number of cylindrical segments that will traverse

## ◆ NumberOfSides() [1/2]

unsigned int Gls3DCable::NumberOfSides | ( |  | ) |

Gets the number of sides.

Returns
  The number of sides on the cable.

## ◆ NumberOfSides() [2/2]

void Gls3DCable::NumberOfSides | ( | unsigned int | value | ) |

Sets the number of sides The more sides, the smoother the cable will appear.

A value of two will produce a ribbon-like cable.
A value of one will render only a line.

Parameters

  value | The number of sides the cable "tube" will have.

## ◆ Radius() [1/2]

float Gls3DCable::Radius | ( |  | ) |

Gets the radius of the cable.

Returns
  The radius in logical units.

## ◆ Radius() [2/2]

void Gls3DCable::Radius | ( | float | value | ) |

Sets the radius of the cable.

Parameters

  value | The radius in logical units.

The documentation for this class was generated from the following file:

- Gls3DCable.i